// http://javadoc.jenkins-ci.org/
import hudson.model.Computer
import hudson.model.Item
import hudson.security.GlobalMatrixAuthorizationStrategy
import hudson.security.Permission
import hudson.slaves.OfflineCause
import jenkins.model.Jenkins
import jenkins.model.JenkinsLocationConfiguration

def strategy = new hudson.security.GlobalMatrixAuthorizationStrategy()


// FIXME: Authenticated users rights definition is missing -- vila 2018-03-09
// Anonymous users can read
strategy.add(jenkins.model.Jenkins.READ, 'anonymous')
strategy.add(hudson.model.Item.READ, 'anonymous')

strategy.add(jenkins.model.Jenkins.ADMINISTER, 'admin')
// If it turns out that admin access is too much for lp:~brz, think about
// lp:~brz-ci-admins -- vila 2017-11-22
strategy.add(jenkins.model.Jenkins.ADMINISTER, '{{byoci}.admin.team}')
// The monitor is an admin too
strategy.add(jenkins.model.Jenkins.ADMINISTER, '{{byoci}.monitor.user}')
 
def jenk = jenkins.model.Jenkins.getInstance();
jenk.setAuthorizationStrategy(strategy)

// Disable job execution on the master
def why = new hudson.slaves.OfflineCause.ByCLI(
    'No job execution allowed on master')
jenk.toComputer().setTemporarilyOffline(true, why)
jenk.setNumExecutors(0)

def public_url = '{{byoci}.master.url}'
if (public_url != 'default') {
    jlc = jenkins.model.JenkinsLocationConfiguration.get()
    jlc.setUrl(public_url) 
    jlc.setAdminAddress('{{byoci}.admin.email}') 
    jlc.save()
}
jenk.save()
